#include <stc12c5a60s2.h>
#define FOSC 12000000L

unsigned char length,HZ;
unsigned long PCHZ,count,m,lowest_PCHZ,Acc_m,Dec_m,L_PCHZ;
unsigned long Acc_Inplace,Dec_Inplace;
unsigned long increasing,decline;

sbit direction=P0^6;
sbit PWM0=P1^3;
sbit enable=P3^2;
sbit led1=P0^7;

unsigned char yb,syb;

bit pause_busy,stop_busy,busy,Timer1_busy;
bit pause,go_ahead,stop,reset;
bit USART_Flag=0;
bit Acc_flag,Dec_flag;
bit flag=0;
bit Trans_pause_busy;

void ENPCA_Init()  //PWMʼ
{
	CCON=0 ;
	CMOD |=0x05;
	CL=0;CH=0;
	CR=1;
}
void Timer0_Init(unsigned char tt)
{
	AUXR |=0x80;
	TMOD |=0x02;
	TH0= tt;
	TL0= tt;
	TR0= 1;
}

void send(unsigned char send_data)  //ڷͺ
{
	SBUF=send_data;
	while(!TI);
}

void PWM_OUT(unsigned char channel,unsigned char start_value)  //PWM 
{
	if(channel == 0)
	{
		CCAP0L = start_value;	//Set the initial value same as CCAP0H
		CCAP0H = start_value;	//25% Duty Cycle
		CCAPM0 = 0x53;			//0x42 Setup PCA module 0 in PWM mode
	}

	if(channel == 1)
	{
		CCAP1L = start_value;	//Set the initial value same as CCAP1H
		CCAP1H = start_value;	//25% Duty Cycle
		CCAPM1 = 0x73;			//0x42 Setup PCA module 1 in PWM mode
	}	
}

void Set_Function1()   //ú
{		
	if(set_data[2]==0xFF)
	{
	 	flag=0;Dec_flag=0;Acc_flag=0;
		if(!busy)
		{
			count=set_data[3]*65536+set_data[4]*256+set_data[5];
			PCHZ=set_data[6]*256+set_data[7];
			HZ=(256-(FOSC/256/PCHZ));
			direction=(set_data[8]&0x01);
			enable=(set_data[8]&0x02)>>1;
			if(enable)
			{
				
				PWM_OUT(0,0X80);
				ENPCA_Init();
				Timer0_Init(HZ);
			}
		}
		else 
		{send('D');}
	}
	else if (set_data[2]==0xFE)
	{
		Acc_flag=1;flag=1;
		count=set_data[3]*65536+set_data[4]*256+set_data[5];
		lowest_PCHZ=set_data[6]*256+set_data[7];
		L_PCHZ=lowest_PCHZ;
		HZ=(256-(FOSC/256/lowest_PCHZ));
		PCHZ=set_data[8]*256+set_data[9];
	   	direction=(set_data[10]&0x01);
		enable=(set_data[10]&0x02)>>1;
		if(enable)
		{
			PWM_OUT(0,0x80);
			ENPCA_Init();
			Timer0_Init(HZ);	
		}
	}
	else
	{
		if(!busy)
		{
			if(set_data[2]<=0x04)
			{
				flag=0;Acc_flag=0;Dec_flag=0;
				if(set_data[2]==0x01)
				{count=set_data[3]*65536+set_data[4]*256+set_data[5];}
				else if(set_data[2]==0x02)
				{
					PCHZ=set_data[3]*256+set_data[4];
					HZ=(256-(FOSC/256/PCHZ));	
				}
				else if(set_data[2]==0x03)
				{direction=(set_data[3]&0x01);}
				else if(set_data[2]==0x04)
				{enable=(set_data[3]&0x01);}
				if(enable)
				{
					PWM_OUT(0,0X80);
					ENPCA_Init();
					Timer0_Init(HZ);
				}
			}
			else
			{
				flag=1;Dec_flag=0;Acc_flag=1;
				if(set_data[2]==0x05)
				{count=set_data[3]*65536+set_data[4]*256+set_data[5];}
				if(set_data[2]==0x06)
				{
					lowest_PCHZ=set_data[6]*256+set_data[7];
					L_PCHZ=lowest_PCHZ;
					HZ=(256-(FOSC/256/lowest_PCHZ));
				}
				else if(set_data[2]==0x07)
				{PCHZ=set_data[8]*256+set_data[9];}	
				else if(set_data[2]==0x08)
				{direction=(set_data[3]&0x01);}
				else if(set_data[2]==0x09)
				{enable=(set_data[3]&0x01);}
				if(enable)
				{
					Acc_flag=1;
					PWM_OUT(0,0X80);
					ENPCA_Init();
					Timer0_Init(HZ);
				}	
			}			
		}
		else
		{
			if(set_data[2]==0x0A)
			{pause=set_data[3]&0x01;}
			if(set_data[2]==0x0B)
			{go_ahead=set_data[3]&0x01;}
			if(set_data[2]==0x0C)
			{stop=set_data[3]&0x01;}
			if(set_data[2]==0x0D)
			{reset=set_data[3]&0x01;}	
		}
		
	}
}


void Modbus_Init(unsigned char cc)	 //moudbusЭת				
{
	unsigned char i,t;
	for(i=1;i<=(cc-3);i++)
	{
		if((rsbuf[i]>=0x30)&&(rsbuf[i]<=0x39))
		{
			if(i%2)
			{rsbuf[i]=(rsbuf[i]-0x30)<<4;}
			else 
			{rsbuf[i]=rsbuf[i]-0x30;}
		}
		else if((rsbuf[i]>=0x41)&&(rsbuf[i]<=0x46))
		{
			if(i%2)
			{rsbuf[i]=(rsbuf[i]-0x37)<<4;}
			else 
			{rsbuf[i]=rsbuf[i]-0x37;}			
		}
		else if((rsbuf[i]>=0x61)&&(rsbuf[i]<=0x66))
		{
			if(i%2)
			{rsbuf[i]=(rsbuf[i]-0x47)<<4;}
			else 
			{rsbuf[i]=rsbuf[i]-0x47;}			
		}
	 }
	t=1;
	for(i=1;i<=(cc-3);i=i+2)
	{
		if(t<=((cc-3)>>1))
		{
			set_data[t]=rsbuf[i]+rsbuf[i+1];
			t++;	
		}
		else
		{t=0;}
	}
}


void Serical_Init()	    //ڳʼ
{
	PCON |= 0x80;		//ʹܲʱλSMOD
	SCON = 0x50;		//8λ,ɱ䲨
	BRT = 0xFA;		//趨ʷװֵ
	AUXR |= 0x04;		//ʷʱΪFosc,1T
	AUXR |= 0x01;		//1ѡʷΪʷ
	AUXR |= 0x10;		//ʷ
	ES=1;	
}

void Clear_Function()	   //PWMλպ
{
	if(m==1)
	{
		send('4');
	}

	if(m>=count)
	{
		TR0=0;CR=0;busy=0;enable=0;
		send(m/65536);
		send((m%65536)/256);
		send(((m%65536)%256)%256);
		m=0;
		PCHZ=0;
		count=1;
		lowest_PCHZ=0;
		Dec_flag=0;	
		Acc_flag=0;
		flag=0;
	}
	if(flag)
	{
		if(lowest_PCHZ<PCHZ)
		{
			HZ=(256-(FOSC/256/lowest_PCHZ));
			Timer0_Init(HZ);
		}
		else 
		{
			Acc_flag=0;Dec_flag=0;
			HZ=(256-(FOSC/256/PCHZ));
			Timer0_Init(HZ);
		}
		if(m>=count-Acc_m)
		{
			Dec_flag=1;
			Acc_flag=0;
			if(lowest_PCHZ<=L_PCHZ)
			{
				Dec_flag=0;
				lowest_PCHZ=L_PCHZ;
			}
		}
	}
}

void USART_Data()	//ڽݴ
{
	unsigned char ii;
	for(ii=0;ii<=length-1;ii++)
	{
		ssbuf[ii]=rsbuf[ii]; 
	}
	Modbus_Init(length);
	if(set_data[1]==0x01)
	{
		Set_Function1();
		yb=0;				
	}	
}


void Pause_Function()	  //PWMͣ
{
	if(Acc_flag | Dec_flag)
	{
		CR=0;
		TR0=0;
		count=count-m;
		send(m/65536);
		send((m%65536)/256);
		send(((m%65536)%256)%256);
		m=0;	
		Trans_pause_busy=1;
	}
	else
	{
		CR=0;
		TR0=0;
		count=count-m;
		send(m/65536);
		send((m%65536)/256);
		send(((m%65536)%256)%256);
		m=0;
		pause_busy=1;	
	}
}

void Go_ahead_Function()  //PWMͣ
{
	if(Trans_pause_busy)
	{
		CR=1;
		TR0=1;
		flag=1;					 
		Trans_pause_busy=0;
	}
	else if (pause_busy)
	{
		CR=1;
		TR0=1;
		flag=0;					 
		pause_busy=0;	
	}	
}

void Stop_Function()  //PWMֹͣ
{
	stop_busy=1;
	CR=0;TR0=0;
	count=count-m;
	m=0;	
}

void Reset_Function()  //PWMλ
{
	if(stop_busy)
	{
		if(direction)
		{
			direction=0;
			flag=0;
			Timer0_Init(15);
			TR0=1;
			CR=1;
			stop_busy=0;
		}
		else
		{
			flag=0;
			Timer0_Init(15);
			TR0=1;
			CR=1;
			stop_busy=0;	
		}
	}	
}
					 
void main()			   //
{
	enable=0;
	direction=0;
	P2=0x01;
	Serical_Init();
	EA=1;
	busy=0;
	CR=0;
	IPH |=0x10;
	PS =1;
	while(1)
	{
		if(USART_Flag) 					//жǷյ
		{
			USART_Flag=0; 				//жϱλ
			USART_Data();				//
		}
		Clear_Function();
		if(pause)  						//жǷյָͣ
		{pause=0;Pause_Function();}
		if(go_ahead)  					//жǷյָ
		{go_ahead=0;Go_ahead_Function();}
		if(stop)	 					//жǷյָֹͣ
		{stop=0;Stop_Function();}
		if(reset)	 					//жǷյλָ
		{reset=0;Reset_Function();}
	}
}


void Serical_Interrupt() interrupt 4		//жϺ
{
	unsigned char temp,temp_next;
	if(RI)
	{
		RI=0;
		temp=SBUF;							   
		rsbuf[yb]=temp;
		yb++;  
		led1=0;
		if((rsbuf[0]==':')&&(temp_next=0x0D)&&(temp==0x0A))
		{
			length=yb;
			USART_Flag=1;				
		}
		temp_next=temp;	
	}
	if(TI)
	{TI=0;}
}

void PCA_Interrupt ()interrupt 7	   //PWMжϺ
{
	CF=0;CCF0=0;	
	m++;
	busy=1;	
	if(Acc_flag)
	{
		{lowest_PCHZ++;}
		if(lowest_PCHZ==PCHZ)
		{
			Acc_m=m;
			Acc_flag=0;	
		}
	}
	if(Dec_flag)
	{
		{lowest_PCHZ--;}
	}
}

